local Event = require 'utils.event'
local Token = require 'utils.token'
local Task = require 'utils.task'

local delayed_restore_character = Token.register(function()
    for i = 1, #game.players do
        local player = game.players[i]
        local character = player.character
        if character then
            character.destroy()
        end
        player.set_controller {type = defines.controllers.god}
        player.create_character()
    end
end)

local function on_player_created(event)
    local player = game.get_player(event.player_index)

    local character = player.character
    if character and character.valid then
        player.character.destroy()
    end
    player.set_controller {type = defines.controllers.ghost}
    Task.set_timeout_in_ticks(600, delayed_restore_character, {})
end

Event.add(defines.events.on_player_created, on_player_created)
